



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>从零开始山寨Caffe&#183;捌：IO系统(二)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">从零开始山寨Caffe&#183;捌：IO系统(二)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-10 22:12:55 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>生产者</h2>
<h3>双缓冲组与信号量机制</h3>
<p>在第陆章中提到了，如何模拟，以及取代根本不存的Q.full()函数。</p>
<p>其本质是：<strong>除了为生产者提供一个成品缓冲队列，还提供一个零件缓冲队列。</strong></p>
<p>当我们从外部给定了固定容量的零件之后，生产者的产能就受到了限制。</p>
<p>由两个阻塞队列组成的QueuePair，并不是Caffe的独创，它实际上是生产者与消费者的编程方式之一。</p>
<p>在大部分操作系统教材中，双缓冲区free、full通常由两个信号量empty、full实现。</p>
<p>信号量（Semaphore）由操作系统底层实现，并且几乎没有人会直接使用信号量去编程。</p>
<p>因为在逻辑上，可以由信号量可由mutex+计数器模拟得到。</p>
<p>信号量的名字很有趣，它实际上由两部分组成，信号(激活信号）、量（计数器）。</p>
<p>汉语的博大精深恰当地诠释的信号量的语义精神，而从Semaphore中，你读不出任何精华。</p>
<p>激活信号掩盖了mutex的功与名，信号量的第一大功能，就是mutex锁。</p>
<p>量，显然表明信号量可以计数，实际上，信号量经常会被拿来为临界资源计数。</p>
<p>下面的伪代码摘自我的操作系统课本，《计算机操作系统 &lt;第四版&gt; 汤小丹等 著》：</p>
<div>
<pre class="prettyprint linenums">int in=,out=;<br />
item buffer[n];<br />
semaphore mutex=,empty=n,full=;<br />
void wait(S){<br />
    while(S&lt;=);<br />
    S--;<br />
}<br />
void signal(S) {S++;}<br />
void producer{<br />
    while(){<br />
        produce an item in nexp;<br />
        ...<br />
        wait(empty);<br />
        wait(mutex);<br />
        buffer[in]=nexp;<br />
        in=(in+)%n;<br />
        signal(mutex);<br />
        signal(full);<br />
    }<br />
}</pre>
</div>
<p>可以看到，除了mutex履行其互斥锁的职责之外，empty和full用来计数。</p>
<p>作为生产者，每次生产时，都要让empty减1，让full加1。</p>
<p>当empty小于等于零时，形成第二把锁，当然，这把锁不是为了互斥，只是为了阻塞。</p>
<p>为了增加效率，这第二把锁可以修改成条件阻塞，让生产者交出CPU控制权，当然这需要操作系统的支持。</p>
<p>信号量在现代编程中是多余的，事实上，也没有哪个线程库会提供。</p>
<p>当"量"为1时，信号量通常是去实现互斥锁功能。</p>
<p>当"量"为临界资源数量时，信号量通常是去实现资源计数、并且条件阻塞的功能。</p>
<p>这两部分的精神内涵都在Blocking Queue中实现了，So，忘记信号量吧。</p>
<h3>多生产者单缓冲区</h3>
<p>作为一般的机器学习玩家，你是用不着考虑多生产者的。</p>
<p>如果你比较有钱，经常喜欢摆弄4-way泰坦交火，那么就需要考虑一下多生产者的模型了。</p>
<p>在第肆章中，介绍了多GPU的基本运行原理，给出了如下这张图：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/678029/201603/678029-20160309191903460-239963314.png" /></p>
<p>对于每个GPU而言，它至少需要一个对它负责的DataReader，每个DataRedaer应当有不同的数据来源。</p>
<p>Caffe中，将控制一个数据来源的类对象称为Body，默认有一个类静态成员的Body关联容器：</p>
<div>
<pre class="prettyprint linenums">class DataReader<br />
{<br />
public:<br />
    .....<br />
private:<br />
    static map&lt;string, boost::weak_ptr&lt;Body&gt; &gt; global_bodies;<br />
};</pre>
</div>
<p>值得注意的是，此处应该使用weak_ptr，而不是shared_ptr，因为Body本身将由一个shared_ptr控制。</p>
<p>将Body的shared_ptr存入map容器，将会导致指针计数器永远为1。</p>
<p>这样，当我们准备将Body从map容器中清除时，无法获知它是否已经被释放。</p>
<p>而weak_ptr指向shared_ptr时，不会增加指针计数器计数，当计数为0时，即可将其从map里清除。</p>
<p>每一个DataReader只能拥有一个Body，而每个Body可以有多个成品存储缓冲区(非用于零件缓冲，下节讲)。</p>
<p>每个Body控制一个数据来源，不同的数据来源可以用关键字来hash，默认Caffe提供的关键字是：</p>
<div>
<pre class="prettyprint linenums">static string source_key(const LayerParameter&amp; param){<br />
    return param.name() + ":" + param.data_param().source();<br />
}</pre>
</div>
<p>即Layer名，加上数据库路径。</p>
<p>多生产者主要用于多数据库同时并行训练，这是一种非常经典的模型。</p>
<p>一部分代码涉及到上层的DataLayer，将后续详解。</p>
<p>另外一种模型是单生产者，以单数据库，不同数据区域同时并行训练，该方法也可以采用。（下节讲）</p>
<p>Caffe的默认源码中，既没有完整实现多生产者并行模型，也没有完整实现单生产者并行模型，这点令人遗憾。</p>
<p>不过，从源码中仍然可以看出一点端倪，本教程只介绍大体思路，同样并不提供具体代码。</p>
<h3>单生产者多缓冲区</h3>
<p>在这种模型下，将只有一个DataReader，一个Body，但是有多个Pair，如图：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/678029/201603/678029-20160312015319757-1918739290.png" /></p>
<p>有趣的是，Body结构体中，提供了QueuePair数组容器：</p>
<div>
<pre class="prettyprint linenums">class Body :public DragonThread{<br />
public:<br />
        .......<br />
    BlockingQueue&lt;boost::shared_ptr&lt;QueuePair&gt; &gt; new_pairs;<br />
};</pre>
</div>
<p>但是，Caffe源码中的DataReader，默认只会使用该容器数组的第一个QueuePair，并没有完整实现多缓冲区：</p>
<div>
<pre class="prettyprint linenums">class DataReader<br />
{<br />
public:<br />
    DataReader(const LayerParameter&amp; param){<br />
           ........<br />
         ptr_body-&gt;new_pairs.push(ptr_pair);<br />
    }<br />
    BlockingQueue&lt;Datum*&gt;&amp; free() const  { return ptr_pair-&gt;free; }<br />
    BlockingQueue&lt;Datum*&gt;&amp; full() const  { return ptr_pair-&gt;full; }<br />
private:<br />
    boost::shared_ptr&lt;QueuePair&gt; ptr_pair;<br />
    boost::shared_ptr&lt;Body&gt; ptr_body;<br />
};</pre>
</div>
<p>可以看到，尽管我们设置了Body，存储多个QueuePair，但是提供的外部访问接口，居然直接使用了ptr_pair。</p>
<p>当然，如果你要编程使用多缓冲区，一定要修改DataReader的访问接口。</p>
<p>对于单个数据库的顺序数据读取，如何将顺序资源，平摊到多个缓冲区？</p>
<p>Caffe使用了循环读取法：</p>
<div>
<pre class="prettyprint linenums">void Body::interfaceKernel(){<br />
    boost::shared_ptr&lt;DB&gt; db(GetDB(param.data_param().backend()));<br />
    db-&gt;Open(param.data_param().source(), DB::READ);<br />
    boost::shared_ptr&lt;Cursor&gt; cursor(db-&gt;NewCursor());<br />
    vector&lt;boost::shared_ptr&lt;QueuePair&gt; &gt;  container;<br />
    try{<br />
         ...............<br />
         while (!must_stop()){<br />
            for (int i = ; i &lt; solver_count; i++)<br />
                read_one(cursor.get(), container[i].get());<br />
        }<br />
    } catch (boost::thread_interrupted&amp;) {}<br />
}</pre>
</div>
<p>可以看到，在Body的线程函数中，利用全局管理器提供的solver_count，循环均摊数据到多个QueuePair中。</p>
<p>当你将solver_count设置成大于1时，将可以使用Body中的多个缓冲区QueuePair，这点需要注意。</p>
<h3>单生产者单缓冲区(默认代码)</h3>
<p>仔细思考一下，就会发现，单生产者多缓冲区方案是毫无意义的，看起来我们似乎模拟了多缓冲区。</p>
<p>但是实质只是一个线程，把资源分了一下组，多个组在DataLayer进行消费的时候，又会被合并成一个Batch：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/678029/201603/678029-20160312022017866-270171524.png" /></p>
<p>如图，因为一个DataLayer只能有一个Prefetching Thread，所以必然是每次从各个Pair里取一次。</p>
<p>如果我们先把Pair0取完，再取Pair1，再取Pair2，这样也是可以的，是一种不错的shuffle，但是需要追加代码。</p>
<p>从计算角度分析，多缓冲区不会加速，反而会减速，如果是为了做上述的shuffle，是情有可原的。</p>
<p>如果不是，只是单纯地为了负载均衡，轮流从各个Pair里取，那么本质上，就会退化成单生产者单缓冲区。</p>
<p>&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;</p>
<p>这可能是Caffe源码的本意。在这种方案中，DataReader和DataLayer是无须改动代码的。</p>
<p>只要我们加大DataParameter里的prefech数值，让CPU多缓冲几个Batch，为多个GPU准备就好了。</p>
<p>三种速度方案排名：</p>
<p>多生产者单缓冲区&gt;单生产者单缓冲区&gt;单生产者多缓冲区</p>
<h3>线程嵌套线程与Socket</h3>
<p>Caffe的源码真的很有启发性，在DataReader的构造和析构函数中，可以发现贡献者悄悄加了mutex：</p>
<div>
<pre class="prettyprint linenums">DataReader::DataReader(const LayerParameter&amp; param){<br />
    ......<br />
    boost::mutex::scoped_lock lock(bodies_mutex);<br />
        ......<br />
}

DataReader::~DataReader(){<br />
        ......<br />
    boost::mutex::scoped_lock lock(bodies_mutex);<br />
        ......<br />
}</pre>
</div>
<p>熟悉C++的人应该知道，在常规情况下，构造和析构函数是不会并行执行的，也就是不会被线程执行。</p>
<p>线程并行的仅仅是工作函数，工作之前主进程构造，工作之后，主进程析构。</p>
<p>如果偏要认为构造和析构可能并行的话，那么将出现一种好玩的情况：</p>
<p>由于DataReader本身是线程，线程并行线程，将导致线程嵌套线程。</p>
<p>在我的操作系统课上，我的老师这么说：</p>
<p><strong>线程仅仅拥有进程的少部分资源，权限很小。</strong></p>
<p>那么线程能够嵌套线程么？经过百度之后，我发现真还可以。</p>
<p>当今的操作系统，无论是Linux，还是Windows，线程的资源权限都是非常大的。</p>
<p>&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;</p>
<p>线程嵌套线程，会不会和多GPU有关？我认为无关。</p>
<p>每个GPU的监督线程，这里我们假设使用DragonThread，在需要工作时，</p>
<p>只需要传入：Solver::solve函数就可以了，Solver、Net、Layer的构造和析构，显然是在主进程里执行的。</p>
<p>那么，线程嵌套线程，有什么意义，有什么情况是必须在线程里触发构造函数？</p>
<p>很有趣，一般来讲，只有Socket线程是这样的。</p>
<p>Socket线程无须使用DragonThread，实际上，Boost的Socket也是由boost::asio而不是boost::thread实现的。</p>
<p>不像多GPU，我们无法预估，在某一时刻，实际有多少个Socket在执行，有多少个用户发出了访问请求。</p>
<p>因此，不能直接把Solver、Net、Layer的构造，放在主进程当中。不然你知道你要构造多少份嘛？显然你不知道。</p>
<p>所以，从直觉上，将这些的构造，放在每一个启动的Socket线程里，用多少，构造多少，看起来不错，如图：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/678029/201603/678029-20160312025401163-886748943.png" /></p>
<p>这样，假如这几个Solver使用了不同数据来源，那么global_bodies就有被几个Solver同时修改的可能。</p>
<p>这是构造和析构函数里，需要加mutex的直接原因。</p>
<p>&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;</p>
<p>Socket的意义何在？</p>
<p>①从训练角度，多个用户可以远程操控一台主机，训练不同的Net。</p>
<p>这点与多GPU训练一个模型是不一样的。一般而言，我们不会认为，多个用户通过Socket，居然想要训练同一个模型。</p>
<p>当然，这也是可以的。</p>
<p>②从测试角度，多个用户，可以利用同一个Net的参数，并行得到自己提供的数据的测试结果。</p>
<p>注意，这样就不要share整个Net，每个用户的solver使用独立的Net，独立读取训练好的参数。</p>
<p>否则，多个用户会在一个Net上卡半天。</p>
<h2>代码实战</h2>
<p>建立data_reader.hpp、data_reader.cpp。</p>
<h3>QueuePair</h3>
<div>
<pre class="prettyprint linenums">class QueuePair{<br />
public:<br />
    QueuePair(const int size);<br />
    ~QueuePair();<br />
    BlockingQueue&lt;Datum*&gt; free; // as producter queue<br />
    BlockingQueue&lt;Datum*&gt; full; // as consumer queue<br />
};</pre>
</div>
<p>QueuePair的结构在上一章已经介绍过，每一个QueuePair将作为一个缓冲区。</p>
<p>QueuePair只需要实现构造函数和析构函数：</p>
<div>
<pre class="prettyprint linenums">QueuePair::QueuePair(const int size){<br />
    // set the upbound for a producter<br />
    for (int i = ; i &lt; size; i++) free.push(new Datum());<br />
}

QueuePair::~QueuePair(){<br />
    // release and clear<br />
    Datum *datum;<br />
    while (free.try_pop(&amp;datum)) delete datum;<br />
    while (full.try_pop(&amp;datum)) delete datum;<br />
}</pre>
</div>
<p>在构造函数中，我们进行"零件"的填充，注意里面的Datum全是空元素，且存入队列的应该是指针。</p>
<p>切记勿存入实体对象Datum，这在应用程序开发中是大忌，因为C++并非Python，默认执行的深拷贝。</p>
<p>深拷贝大内存数据结构体，会严重拖慢程序执行，而且还是没有意义的，传递指针更恰当。</p>
<p>在析构函数中，实际上这是唯一一处对Protocol Buffer对象的主动析构，因为Datum没有用shared_ptr。</p>
<p>主动析构主要利用Blocking Queue提供的try，来控制循环进度。</p>
<p>此处切记不要把pop写成peek，否则会造成对空指针的delete，导致程序崩溃。</p>
<h3>LayerParameter</h3>
<p>DataReader的上层是DataLayer，它是DataLayer的成员变量之一，需要DataLayer提供proto参数。</p>
<p>在你的proto脚本中，追加如下项：</p>
<div>
<pre class="prettyprint linenums">message DataParameter{<br />
    enum DB{<br />
        LEVELDB=;<br />
        LMDB=;<br />
    }<br />
    optional string source=;<br />
    optional uint32 batch_size=;<br />
    optional DB backend= [default=LMDB];<br />
    //4-way pre-buffering is enough for normal machines<br />
    optional uint32 prefech= [default=];<br />
}

message LayerParameter{<br />
    optional string name=;<br />
    optional string type=;<br />
    optional DataParameter data_param=;<br />
}</pre>
</div>
<p>重新编译后，覆盖你的旧头文件和源文件。</p>
<p>DataParameter中，包含：数据库源路径、batch大小、数据库类型，以及预缓冲区大小。</p>
<p>比较特别的是预缓冲大小，默认是开4个Batch的预缓冲。如果你的GPU计算速度过快，明显大于</p>
<p>CPU供给数据的速度，消费者(DataLayer)经常提示缺数据，你得考虑加大预缓冲区数量。</p>
<p>将DataParameter嵌入到LayerParameter中去。</p>
<p>LayerParameter是一个巨型的数据结构，将包含所有类型Layer的超参数，你可以将其视为基类。</p>
<h3>Body</h3>
<div>
<pre class="prettyprint linenums">class Body :public DragonThread{<br />
public:<br />
    Body(const LayerParameter&amp; param);<br />
    virtual ~Body();<br />
    vector&lt;boost::shared_ptr&lt;QueuePair&gt;&gt; new_pairs;<br />
protected:<br />
    void interfaceKernel();<br />
    void read_one(Cursor *cursor, QueuePair *pair);<br />
    LayerParameter param;<br />
};</pre>
</div>
<p>Body实际上是一个线程，而DataReader却不是，尽管Body是DataReader成员变量。</p>
<p>Body的构造函数和析构函数就是启动线程和停止线程：</p>
<div>
<pre class="prettyprint linenums">Body::Body(const LayerParameter&amp; param) :param(param) { startThread();}<br />
Body::~Body() { stopThread();}</pre>
</div>
<p>线程工作函数比较复杂：</p>
<div>
<pre class="prettyprint linenums">void Body::interfaceKernel(){<br />
    boost::shared_ptr&lt;DB&gt; db(GetDB(param.data_param().backend()));<br />
    db-&gt;Open(param.data_param().source(), DB::READ);<br />
    boost::shared_ptr&lt;Cursor&gt; cursor(db-&gt;NewCursor());<br />
    try{<br />
        //    default solver_count=1<br />
        int solver_count = param.phase() == TRAIN ? Dragon::get_solver_count() : ;<br />
        //    working period<br />
        while (!must_stop()){<br />
            for (int i = ; i &lt; solver_count; i++)<br />
                read_one(cursor.get(), new_pairs[i].get());<br />
        }<br />
        //  complex condition<br />
    } catch (boost::thread_interrupted&amp;) {}<br />
}</pre>
</div>
<p>该函数将会一直卡在循环里，直到训练结束，Body执行析构函数，将线程执行停止。</p>
<p>Body-DataReader构成了Caffe数据缓冲的第一级别：<strong>数据库-&gt;Datum </strong>。</p>
<p>在DataLayer中，还会进行第二级别的缓冲：<strong>Datum-&gt;Blob-&gt;Batch</strong>，将在后续分析。</p>
<p>最后，还剩下一个read_one函数：</p>
<div>
<pre class="prettyprint linenums">void Body::read_one(Cursor *cursor, QueuePair *pair){<br />
    Datum *datum = pair-&gt;free.pop();<br />
    datum-&gt;ParseFromString(cursor-&gt;value());<br />
    pair-&gt;full.push(datum);<br />
    cursor-&gt;Next();<br />
    if (!cursor-&gt;valid()){<br />
        DLOG(INFO) &lt;&lt; "Restarting data prefeching from start.\n";<br />
        cursor-&gt;SeekToFirst();<br />
    }<br />
}</pre>
</div>
<p>read_one每次从一个双缓冲组的free队列中取出空Datum指针。</p>
<p>利用Protocol Buffer的反序列化函数ParseFromString，从数据库中还原Datum，再扔到full队列里。</p>
<p>感谢Protocol Buffer，否则这部分的代码估计不下200行。</p>
<p>当数据库跑完之后，需要回到开头，再次重读，为迭代过程反复提供数据。</p>
<p>这一步只适合训练过程，如果你要一次测试自己的数据，请忘记这个函数，重写一个不要反复读的版本。</p>
<h3>DataReader</h3>
<div>
<pre class="prettyprint linenums">class DataReader<br />
{<br />
public:<br />
    DataReader(const LayerParameter&amp; param);<br />
    BlockingQueue&lt;Datum*&gt;&amp; free() const  { return ptr_pair-&gt;free; }<br />
    BlockingQueue&lt;Datum*&gt;&amp; full() const  { return ptr_pair-&gt;full; }<br />
    ~DataReader();<br />
    static string source_key(const LayerParameter&amp; param){<br />
        return param.name() + ":" + param.data_param().source();<br />
    }<br />
private:<br />
    LayerParameter param;<br />
    boost::shared_ptr&lt;QueuePair&gt; ptr_pair;<br />
    boost::shared_ptr&lt;Body&gt; ptr_body;<br />
    static map&lt;string, boost::weak_ptr&lt;Body&gt; &gt; global_bodies;<br />
};</pre>
</div>
<p>该结构上文已经全面解析过。</p>
<p>在cpp的实现中，首先完成类静态成员变量的外部初始化。</p>
<div>
<pre class="prettyprint linenums">map&lt;string, boost::weak_ptr&lt;Body&gt; &gt; DataReader::global_bodies;</pre>
</div>
<p>以及一个静态mutex的定义：</p>
<div>
<pre class="prettyprint linenums">static boost::mutex bodies_mutex;</pre>
</div>
<p>该mutex是Caffe挖的坑之一，虽然默认不会生效，倒是给出了不错的指导。</p>
<p>当构建多生产者单缓冲区时，我们将会有多个Body，即多个DataReader，即多个DragonThread。</p>
<p>这意味着，Body的Hash容器将成为一个互斥资源。</p>
<p>该Hash容器的存在不是没有必要的，由于：</p>
<p>每个数据来源只能用一次，为了避免重复路径，显然需要Hash。</p>
<div>
<pre class="prettyprint linenums">DataReader::DataReader(const LayerParameter&amp; param){<br />
    ptr_pair.reset(new QueuePair(<br />
        param.data_param().prefech()*param.data_param().batch_size()));<br />
    boost::mutex::scoped_lock lock(bodies_mutex);<br />
    string hash_key = source_key(param);<br />
    boost::weak_ptr&lt;Body&gt; weak = global_bodies[hash_key];<br />
    ptr_body = weak.lock();<br />
    if (!ptr_body){<br />
        ptr_body.reset(new Body(param));<br />
        global_bodies[hash_key] = boost::weak_ptr&lt;Body&gt;(ptr_body);<br />
    }<br />
    ptr_body-&gt;new_pairs.push(ptr_pair);<br />
}</pre>
</div>
<p>DataReader的构造函数首先根据用户指定的预缓冲区大小，初始化默认的双缓冲队列组。</p>
<p>接下来，要在Body的Hash容器中登记，mutex锁住，修改之后解锁。</p>
<p>登记所使用的是weak_ptr，weak_ptr可看作shared_ptr的助手，通常视为观察者(Viewer)。</p>
<p>不可使用-&gt;，只能调用lock函数获得shared_ptr。</p>
<p>DataReader的析构，主要任务是析构Body，以及从Hash容器中反登记。</p>
<div>
<pre class="prettyprint linenums">DataReader::~DataReader(){<br />
    string hash_key = source_key(param);<br />
    ptr_body.reset();<br />
    boost::mutex::scoped_lock lock(bodies_mutex);<br />
    if (global_bodies[hash_key].expired()) global_bodies.erase(hash_key);<br />
}</pre>
</div>
<h2>析构体系</h2>
<p>DataReader中涉及几个比较重要的析构，这里以图描述下：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/678029/201603/678029-20160310004638741-2041818036.png" /></p>
<h2>完整代码</h2>
<p>data_reader.hpp</p>
<p><a href="https://github.com/neopenx/Dragon/blob/master/Dragon/data_include/data_reader.hpp" rel="external nofollow noreferrer">https://github.com/neopenx/Dragon/blob/master/Dragon/data_include/data_reader.hpp</a></p>
<p>data_reader.cpp</p>
<p><a href="https://github.com/neopenx/Dragon/blob/master/Dragon/data_src/data_reader.cpp" rel="external nofollow noreferrer">https://github.com/neopenx/Dragon/blob/master/Dragon/data_src/data_reader.cpp</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9pxxw4q.html">javadoc相关问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8o7g11q.html">《ASP&period;NET1200例》ListView 控件与DataPager控件的结合&amp;lt&semi;一&amp;gt&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm34j49.html">Android 中多点触摸协议</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xzvne8.html">ajax返回的json内容进行排序</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1g7038.html">ios App 打包</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm30dx9.html">POJ 2891 扩展欧几里德</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mjdwj8.html">EM 期望最大化算法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1r4y1q.html">我们为什么要使用AOP？</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj03vk8.html">UOJ &num;274&period; 【清华集训2016】温暖会指引我们前行 &lbrack;lct&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpg5jr9.html">LeetCode之&OpenCurlyDoubleQuote;动态规划&rdquo;：Decode Ways</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k76yz9.html">01 JVM 从入门到实战 &vert; 什么是 JVM</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljr4oe9.html">MyX5TbsDemo【体验腾讯浏览服务Android SDK （完整版）】</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjpwwk8.html">ASP&period;NET Core快速入门学习笔记（第3章：依赖注入）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e447vk9.html">IDEA中MAVEN项目有多个子目录，如何加载构建</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxd5ex09.html">linux下下载redis，并且编译</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyvwjp2q.html">webWorker</a>
		</li>
						<li><a href="https://www.batexi.com/a/8koomy6q.html">&equals;&equals;&equals; &dollar; spark sql 的特别的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnny0zjq.html">fio 测试磁盘</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4p7gv0q.html">熟悉一下oncontextmenu事件的知识</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnn61pjq.html">windows下好用的markdown编辑器</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/39rgg6e8.html">Java学习&mdash;&mdash;连接数据库</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jzz6l8.html">robotframework&comma;selenium启动不了打不开浏览器的问题访问不了网页</a>
			</li>
						<li><a href="https://www.batexi.com/a/39rgn1r8.html">《jQuery知识点总结》（一）</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gepgz8.html">CROSS APPLY应用实例</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8ey0nm9.html">ACM&sol;ICPC 之 中国剩余定理&plus;容斥原理&lpar;HDU5768&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxko6v8.html">修改组策略，禁止用户修改IP</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxk5pd8.html">Linux posix线程库总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8oj32pq.html">Excel文件下载功能</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jzvg08.html">【转】理解 PHP 依赖注入 &vert; Laravel IoC容器</a>
			</li>
						<li><a href="https://www.batexi.com/a/390mkpj8.html">Python ToDo List</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
